/*
* chsums/2q3g-static.cpp
*
* This file is part of NJet library
* Copyright (C) 2011, 2012 NJet Collaboration
*
* This software is distributed under the terms of the GNU General Public License (GPL)
*/

#include "2q3g.h"

// class Amp2q3gStatic

const int
Amp2q3gStatic::flav[FC][NN] = {
    {-1,1,0,0,0}
};

const int
Amp2q3gStatic::fvsign[FC] = {1};

const int
Amp2q3gStatic::ccsign[NN*(NN+1)/2] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

const int
Amp2q3gStatic::fperm[FC][NN] = {
    {0,1,2,3,4}
};

const int
Amp2q3gStatic::fvcol[FC][CC] = {
    {0,1,2,3,4,5,6,7,8,9,10}
};

const unsigned char
Amp2q3gStatic::colmat[CC*(CC+1)/2] = {
    1,3,1,3,6,1,6,8,3,1,6,3,8,6,1,8,6,6,3,3,1,0,
    4,0,4,0,0,9,4,0,0,0,0,4,10,9,0,0,4,0,4,0,10,10,
    9,2,5,5,2,2,5,7,7,7,11,5,2,2,5,5,2,7,7,7,12,11
};

const unsigned char
Amp2q3gStatic::colmatcc[NN*(NN+1)/2][C0*(C0+1)/2] = {
    {},
    {11,8,11,8,7,11,7,12,8,11,7,8,12,7,11,12,7,7,8,8,11},
    {},
    {2,3,2,2,1,1,2,3,1,6,1,2,1,2,1,3,2,2,1,1,6},
    {6,1,6,1,2,1,2,3,2,2,2,1,1,1,1,3,2,1,3,2,2},
    {},
    {1,1,6,2,2,2,1,3,3,2,2,1,3,2,6,1,2,1,2,1,1},
    {1,2,2,1,2,6,2,3,1,6,1,3,3,2,2,1,1,2,1,2,1},
    {5,4,4,0,0,5,0,13,4,4,9,4,10,0,5,10,0,9,4,0,5},
    {},
    {6,1,1,1,2,6,2,1,1,1,2,2,3,1,2,3,1,2,2,3,2},
    {2,2,1,3,1,2,1,1,2,1,2,1,3,2,6,3,2,2,1,1,6},
    {4,4,5,4,9,5,0,10,0,5,0,0,10,9,5,13,0,0,4,4,4},
    {5,0,5,4,0,4,9,10,4,5,0,4,13,0,4,10,9,0,0,4,5},
    {}
};

const int
Amp2q3gStatic::HSarr[HS][HSNN] = {
//   {-1, 1, 1, 1, 1},
  {-1, 1, 1, 1,-1},
  {-1, 1, 1,-1, 1},
  {-1, 1, 1,-1,-1},
  {-1, 1,-1, 1, 1},
  {-1, 1,-1, 1,-1},
  {-1, 1,-1,-1, 1},
//   {-1, 1,-1,-1,-1},
//   { 1,-1,-1,-1,-1},
  { 1,-1,-1,-1, 1},
  { 1,-1,-1, 1,-1},
  { 1,-1,-1, 1, 1},
  { 1,-1, 1,-1,-1},
  { 1,-1, 1,-1, 1},
  { 1,-1, 1, 1,-1},
//   { 1,-1, 1, 1, 1}
};

// class Amp2q3g_ds3Static

const unsigned int Amp2q3g_ds3Static::colmatds[CDS][C0] = {
  // L
  {13,  0, 0, 1, 1,  1},
  { 2,  0, 2, 2, 1,  0},
  { 4, 10, 3, 3, 4,  3},
  {12,  5, 5, 8, 8, 14},
  // F
  { 9,  6, 6, 7, 7, 11},
};
