/*
* chsums/4q0gA-static.cpp
*
* This file is part of NJet library
* Copyright (C) 2011, 2012 NJet Collaboration
*
* This software is distributed under the terms of the GNU General Public License (GPL)
*/

#include "4q0gA.h"

// class Amp4q0gAxStatic

const int
Amp4q0gAxStatic::flav[FC][NN] = {
    {-1,1,-2,2}, // ax
    {-1,1,-2,2},
    {-2,2,-1,1},
    {-1,2,-2,1}, // ax
    {-1,2,-2,1},
    {-2,1,-1,2},
};

const int
Amp4q0gAxStatic::fvsign[FC] = {1, 1, 1,-1,-1,-1};

const int
Amp4q0gAxStatic::fperm[FC][NN] = {
    {0,1,2,3}, // ax
    {0,1,2,3},
    {2,3,0,1},
    {0,3,2,1}, // ax
    {0,3,2,1},
    {2,1,0,3}
};

const int
Amp4q0gAxStatic::fvcol[FC][CC] = {
    {0,1}, // ax
    {0,1},
    {0,1},
    {1,0}, // ax
    {1,0},
    {1,0},
};

// class Amp4q0gAx2Static

const int
Amp4q0gAx2Static::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1},
  { 1,-1,-1, 1, 1},
  { 1, 1,-1,-1, 1},
  {-1, 1,-1, 1, 1},
  {-1, 1, 1,-1, 1},
  {-1,-1, 1, 1, 1},
  { 1,-1, 1,-1,-1},
  { 1,-1,-1, 1,-1},
  { 1, 1,-1,-1,-1},
  {-1, 1,-1, 1,-1},
  {-1, 1, 1,-1,-1},
  {-1,-1, 1, 1,-1},
};

// class Amp4q0gAAStatic

const int
Amp4q0gAAStatic::flav[FC][NN] = {
    {-1,1,-2,2},
    {-1,1,-2,2},
    {-2,2,-1,1},
    {-2,2,-1,1},
    {-1,2,-2,1},
    {-1,2,-2,1},
    {-2,1,-1,2},
    {-2,1,-1,2},
};

const int
Amp4q0gAAStatic::fvsign[FC] = {1, 1, 1, 1,-1,-1,-1,-1};

const int
Amp4q0gAAStatic::fperm[FC][NN] = {
    {0,1,2,3},
    {0,1,2,3},
    {2,3,0,1},
    {2,3,0,1},
    {0,3,2,1},
    {0,3,2,1},
    {2,1,0,3},
    {2,1,0,3},
};

const int
Amp4q0gAAStatic::fvcol[FC][CC] = {
    {0,1},
    {0,1},
    {0,1},
    {0,1},
    {1,0},
    {1,0},
    {1,0},
    {1,0},
};

const int
Amp4q0gAAStatic::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1},
  { 1,-1, 1,-1, 1, 1},
  {-1, 1,-1, 1, 1, 1},
  {-1, 1, 1,-1, 1, 1},
  { 1,-1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1},
  {-1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1,-1, 1},
  { 1,-1,-1, 1, 1,-1},
  { 1,-1, 1,-1, 1,-1},
  {-1, 1,-1, 1, 1,-1},
  {-1, 1, 1,-1, 1,-1},
  { 1,-1,-1, 1,-1,-1},
  { 1,-1, 1,-1,-1,-1},
  {-1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1,-1,-1},
};

// class Amp4q0gAA2Static

const int
Amp4q0gAA2Static::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1, 1},
  { 1,-1,-1, 1, 1, 1},
  { 1, 1,-1,-1, 1, 1},
  {-1, 1,-1, 1, 1, 1},
  {-1, 1, 1,-1, 1, 1},
  {-1,-1, 1, 1, 1, 1},
  { 1,-1, 1,-1,-1, 1},
  { 1,-1,-1, 1,-1, 1},
  { 1, 1,-1,-1,-1, 1},
  {-1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1,-1, 1},
  {-1,-1, 1, 1,-1, 1},
  { 1,-1, 1,-1, 1,-1},
  { 1,-1,-1, 1, 1,-1},
  { 1, 1,-1,-1, 1,-1},
  {-1, 1,-1, 1, 1,-1},
  {-1, 1, 1,-1, 1,-1},
  {-1,-1, 1, 1, 1,-1},
  { 1,-1, 1,-1,-1,-1},
  { 1,-1,-1, 1,-1,-1},
  { 1, 1,-1,-1,-1,-1},
  {-1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1,-1,-1},
  {-1,-1, 1, 1,-1,-1},
};

// class Amp4q0gAAxStatic

const int
Amp4q0gAAxStatic::flav[FC][NN] = {
    {-1,1,-2,2}, // ax
    {-1,1,-2,2}, // axx
    {-1,1,-2,2},
    {-1,1,-2,2},
    {-2,2,-1,1},
    {-2,2,-1,1},
    {-1,2,-2,1}, // ax
    {-1,2,-2,1}, // axx
    {-1,2,-2,1},
    {-1,2,-2,1},
    {-2,1,-1,2},
    {-2,1,-1,2},
};

const int
Amp4q0gAAxStatic::fvsign[FC] = {1, 1, 1, 1, 1, 1,-1,-1,-1,-1,-1,-1};

const int
Amp4q0gAAxStatic::fperm[FC][NN] = {
    {0,1,2,3}, // ax
    {0,1,2,3}, // axx
    {0,1,2,3},
    {0,1,2,3},
    {2,3,0,1},
    {2,3,0,1},
    {0,3,2,1}, // ax
    {0,3,2,1}, // axx
    {0,3,2,1},
    {0,3,2,1},
    {2,1,0,3},
    {2,1,0,3},
};

const int
Amp4q0gAAxStatic::fvcol[FC][CC] = {
    {0,1}, // ax
    {0,1}, // axx
    {0,1},
    {0,1},
    {0,1},
    {0,1},
    {1,0}, // ax
    {1,0}, // axx
    {1,0},
    {1,0},
    {1,0},
    {1,0},
};

// class Amp4q0gAAx2Static

const int
Amp4q0gAAx2Static::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1, 1},
  { 1,-1,-1, 1, 1, 1},
  { 1, 1,-1,-1, 1, 1},
  {-1, 1,-1, 1, 1, 1},
  {-1, 1, 1,-1, 1, 1},
  {-1,-1, 1, 1, 1, 1},
  { 1,-1, 1,-1,-1, 1},
  { 1,-1,-1, 1,-1, 1},
  { 1, 1,-1,-1,-1, 1},
  {-1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1,-1, 1},
  {-1,-1, 1, 1,-1, 1},
  { 1,-1, 1,-1, 1,-1},
  { 1,-1,-1, 1, 1,-1},
  { 1, 1,-1,-1, 1,-1},
  {-1, 1,-1, 1, 1,-1},
  {-1, 1, 1,-1, 1,-1},
  {-1,-1, 1, 1, 1,-1},
  { 1,-1, 1,-1,-1,-1},
  { 1,-1,-1, 1,-1,-1},
  { 1, 1,-1,-1,-1,-1},
  {-1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1,-1,-1},
  {-1,-1, 1, 1,-1,-1},
};

