/*
* chsums/6q0gV-static.cpp
*
* This file is part of NJet library
* Copyright (C) 2011, 2012 NJet Collaboration
*
* This software is distributed under the terms of the GNU General Public License (GPL)
*/

#include "6q0gV.h"

// class Amp6q0gVStatic

const int
Amp6q0gVStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
};

// class Amp6q0gV2Static

const int
Amp6q0gV2Static::HSarr[HS][HSNN] = {
  { 1,-1, 1, 1,-1,-1, 1},
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1,-1,-1, 1, 1, 1},
};

// class Amp6q0gV2nStatic

const int
Amp6q0gV2nStatic::flav[FC][NN] = {
  {-1,1,-2,2,-3,3},
  {-1,2,-2,1,-3,3},
  {-1,2,-2,3,-3,1},
  {-1,3,-2,2,-3,1},
  {-1,3,-2,1,-3,2},
  {-1,1,-2,3,-3,2},
};

const int
Amp6q0gV2nStatic::fperm[FC][NN] = {
  {0,1,2,3,4,5},
  {0,3,2,1,4,5},
  {0,5,2,1,4,3},
  {0,5,2,3,4,1},
  {0,3,2,5,4,1},
  {0,1,2,5,4,3},
};

const int
Amp6q0gV2nStatic::fvcol[FC][CC] = {
  {0,1,2,3,4,5},
  {4,2,1,5,0,3},
  {1,5,4,2,3,0},
  {2,3,0,1,5,4},
  {5,0,3,4,2,1},
  {3,4,5,0,1,2},
};

const int
Amp6q0gV2nStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1, 1,-1,-1, 1,-1, 1},
  { 1, 1,-1,-1,-1, 1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
};

// class Amp6q0gV6nStatic

const int
Amp6q0gV6nStatic::HSarr[HS][HSNN] = {
  { 1, 1, 1,-1,-1,-1, 1},
  { 1, 1,-1, 1,-1,-1, 1},
  { 1, 1,-1,-1, 1,-1, 1},
  { 1, 1,-1,-1,-1, 1, 1},
  { 1,-1, 1, 1,-1,-1, 1},
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1,-1,-1, 1, 1, 1},
};

// class Amp6q0gV2bStatic

const int
Amp6q0gV2bStatic::flav[FC][NN] = {
  {-1,1,-2,2,-3,3},
  {-2,1,-1,2,-3,3},
  {-2,1,-3,2,-1,3},
  {-3,1,-2,2,-1,3},
  {-3,1,-1,2,-2,3},
  {-1,1,-3,2,-2,3},
};

const int
Amp6q0gV2bStatic::fperm[FC][NN] = {
  {0,1,2,3,4,5},
  {2,1,0,3,4,5},
  {4,1,0,3,2,5},
  {4,1,2,3,0,5},
  {2,1,4,3,0,5},
  {0,1,4,3,2,5},
};

const int
Amp6q0gV2bStatic::fvcol[FC][CC] = {
  {0,1,2,3,4,5},
  {2,4,0,5,1,3},
  {5,0,4,2,3,1},
  {3,2,1,0,5,4},
  {1,5,3,4,2,0},
  {4,3,5,1,0,2},
};

const int
Amp6q0gV2bStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  {-1,-1, 1, 1, 1,-1, 1},
  {-1,-1, 1, 1,-1, 1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
};

// class Amp6q0gV6bStatic

const int
Amp6q0gV6bStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1, 1,-1,-1, 1},
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1,-1,-1, 1, 1, 1},
  {-1,-1,-1, 1, 1, 1, 1},
  {-1,-1, 1,-1, 1, 1, 1},
  {-1,-1, 1, 1,-1, 1, 1},
  {-1,-1, 1, 1, 1,-1, 1},
};

// class Amp6q0gV4nbStatic

const int
Amp6q0gV4nbStatic::flav[FC][NN] = {
  {-1,1,-2,2,-3,3},
  {-1,2,-2,1,-3,3},
  {-3,1,-2,2,-1,3},
  {-3,2,-2,1,-1,3},
};

const int
Amp6q0gV4nbStatic::fperm[FC][NN] = {
  {0,1,2,3,4,5},
  {0,3,2,1,4,5},
  {4,1,2,3,0,5},
  {4,3,2,1,0,5},
};

const int
Amp6q0gV4nbStatic::fvcol[FC][CC] = {
  {0,1,2,3,4,5},
  {4,2,1,5,0,3},
  {3,2,1,0,5,4},
  {5,1,2,4,3,0},
};

const int
Amp6q0gV4nbStatic::fvsign[FC] = {1,-1,-1,1};

const int
Amp6q0gV4nbStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1, 1,-1,-1, 1,-1, 1},
  { 1, 1,-1,-1,-1, 1, 1},
  {-1,-1, 1,-1, 1, 1, 1},
  {-1,-1,-1, 1, 1, 1, 1},
  {-1, 1,-1,-1, 1, 1, 1},
};

// class Amp6q0gZstatic

const int
Amp6q0gZStatic::flav[FC][NN] = {
  // 1 2 3
  {-1,1,-2,2,-3,3},
  {-3,3,-1,1,-2,2},
  {-2,2,-3,3,-1,1},
  // 2 1 3
  {-1,2,-2,1,-3,3},
  {-3,1,-1,3,-2,2},
  {-2,3,-3,2,-1,1},
  // 2 3 1
  {-1,2,-2,3,-3,1},
  {-3,1,-1,2,-2,3},
  {-2,3,-3,1,-1,2},
  // 3 2 1
  {-1,3,-2,2,-3,1},
  {-3,2,-1,1,-2,3},
  {-2,1,-3,3,-1,2},
  // 3 1 2
  {-1,3,-2,1,-3,2},
  {-3,2,-1,3,-2,1},
  {-2,1,-3,2,-1,3},
  // 1 3 2
  {-1,1,-2,3,-3,2},
  {-3,3,-1,2,-2,1},
  {-2,2,-3,1,-1,3},
};

const int
Amp6q0gZStatic::fvsign[FC] = {1, 1, 1,-1,-1,-1, 1, 1, 1,-1,-1,-1, 1, 1, 1,-1,-1,-1};

const int
Amp6q0gZStatic::fperm[FC][NN] = {
  {0,1,2,3,4,5},
  {2,3,4,5,0,1},
  {4,5,0,1,2,3},
  //
  {0,3,2,1,4,5},
  {2,1,4,5,0,3},
  {4,5,0,3,2,1},
  //
  {0,5,2,1,4,3},
  {2,1,4,3,0,5},
  {4,3,0,5,2,1},
  //
  {0,5,2,3,4,1},
  {2,3,4,1,0,5},
  {4,1,0,5,2,3},
  //
  {0,3,2,5,4,1},
  {2,5,4,1,0,3},
  {4,1,0,3,2,5},
  //
  {0,1,2,5,4,3},
  {2,5,4,3,0,1},
  {4,3,0,1,2,5},
};

const int
Amp6q0gZStatic::fvcol[FC][CC] = {
  {0,1,2,3,4,5},
  {0,1,4,2,3,5},
  {0,1,3,4,2,5},
  {4,2,1,5,0,3},
  {4,2,0,1,5,3},
  {4,2,5,0,1,3},
  {1,5,4,2,3,0},
  {1,5,3,4,2,0},
  {1,5,2,3,4,0},
  {2,3,0,1,5,4},
  {2,3,5,0,1,4},
  {2,3,1,5,0,4},
  {5,0,3,4,2,1},
  {5,0,2,3,4,1},
  {5,0,4,2,3,1},
  {3,4,5,0,1,2},
  {3,4,1,5,0,2},
  {3,4,0,1,5,2},
};

const int
Amp6q0gZStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  {-1, 1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1,-1, 1, 1},
  {-1, 1,-1, 1, 1,-1, 1},
  {-1, 1,-1, 1,-1, 1, 1},
  { 1,-1, 1,-1, 1,-1,-1},
  { 1,-1, 1,-1,-1, 1,-1},
  { 1,-1,-1, 1, 1,-1,-1},
  { 1,-1,-1, 1,-1, 1,-1},
  {-1, 1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1,-1, 1,-1},
  {-1, 1,-1, 1, 1,-1,-1},
  {-1, 1,-1, 1,-1, 1,-1},
};

const int
Amp6q0gZ2Static::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1,-1, 1,-1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1,-1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1,-1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1,-1, 1,-1, 1,-1,-1},
  { 1,-1, 1,-1, 1,-1, 1},
  { 1, 1,-1,-1,-1, 1,-1},
  { 1, 1,-1,-1,-1, 1, 1},
  { 1, 1,-1,-1, 1,-1,-1},
  { 1, 1,-1,-1, 1,-1, 1},
  {-1,-1, 1, 1,-1, 1,-1},
  {-1,-1, 1, 1,-1, 1, 1},
  {-1,-1, 1, 1, 1,-1,-1},
  {-1,-1, 1, 1, 1,-1, 1},
  {-1, 1,-1, 1,-1, 1,-1},
  {-1, 1,-1, 1,-1, 1, 1},
  {-1, 1,-1, 1, 1,-1,-1},
  {-1, 1,-1, 1, 1,-1, 1},
  {-1, 1, 1,-1,-1, 1,-1},
  {-1, 1, 1,-1,-1, 1, 1},
  {-1, 1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1, 1,-1, 1},
};

const int
Amp6q0gZ6Static::HSarr[HS][HSNN] = {
  { 1,-1,-1,-1, 1, 1,-1},
  { 1,-1,-1,-1, 1, 1, 1},
  { 1,-1,-1, 1,-1, 1,-1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1,-1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1, 1,-1,-1, 1,-1},
  { 1,-1, 1,-1,-1, 1, 1},
  { 1,-1, 1,-1, 1,-1,-1},
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1, 1,-1,-1,-1},
  { 1,-1, 1, 1,-1,-1, 1},
  { 1, 1,-1,-1,-1, 1,-1},
  { 1, 1,-1,-1,-1, 1, 1},
  { 1, 1,-1,-1, 1,-1,-1},
  { 1, 1,-1,-1, 1,-1, 1},
  { 1, 1,-1, 1,-1,-1,-1},
  { 1, 1,-1, 1,-1,-1, 1},
  { 1, 1, 1,-1,-1,-1,-1},
  { 1, 1, 1,-1,-1,-1, 1},
  {-1,-1,-1, 1, 1, 1,-1},
  {-1,-1,-1, 1, 1, 1, 1},
  {-1,-1, 1,-1, 1, 1,-1},
  {-1,-1, 1,-1, 1, 1, 1},
  {-1,-1, 1, 1,-1, 1,-1},
  {-1,-1, 1, 1,-1, 1, 1},
  {-1,-1, 1, 1, 1,-1,-1},
  {-1,-1, 1, 1, 1,-1, 1},
  {-1, 1,-1,-1, 1, 1,-1},
  {-1, 1,-1,-1, 1, 1, 1},
  {-1, 1,-1, 1,-1, 1,-1},
  {-1, 1,-1, 1,-1, 1, 1},
  {-1, 1,-1, 1, 1,-1,-1},
  {-1, 1,-1, 1, 1,-1, 1},
  {-1, 1, 1,-1,-1, 1,-1},
  {-1, 1, 1,-1,-1, 1, 1},
  {-1, 1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1, 1,-1, 1},
  {-1, 1, 1, 1,-1,-1,-1},
  {-1, 1, 1, 1,-1,-1, 1},
};
